// directly, apart from some name changes and removals, ripped off from NeHe tutorial #30
// (read explanation near function do2005Physics() in beginning.cc)

/*******************************************************************************/
/*********************************21/09/200*************************************/
/**********************Programmer: Dimitrios Christopoulos**********************/
/**********************for the oglchallenge contest*****************************/
/**********************COLLISION CRAZY******************************************/
/*******************************************************************************/
#include "ray.hh"
#include <math.h>

// Line betwen two points OR point and a direction
Ray::Ray(const Vector &point1, const Vector &point2)
: _P(point1) {
	_V = (point2.isUnit() ? point2 : Vector::unit(point2-point1));
}


bool Ray::adjacentPoints(const Ray &ray, Vector &point1, Vector &point2) const {
	if (isValid() && ray.isValid())
	{
		double temp = Vector::dot(_V, ray._V);
		double temp2 = 1.0 - (temp * temp);
		Vector tv; // Temporary vector to enable use of optimised routines


		// Check for parallel rays
		if (fabs(temp2)<1.0e-8) {
			double mu = Vector::dot(_V, _P-ray._P)/temp;
			point1 = _P;
			Vector::add(ray._P, Vector::multiply(ray._V, mu, tv), point2);
		} else {
			double a = Vector::dot(_V, Vector::subtract(ray._P, _P, tv));
			double b = Vector::dot(ray._V, Vector::subtract(_P, ray._P, tv));
			double mu = (b + temp*a)/temp2;
			double lambda = (a + temp*b)/temp2;
			Vector::add(_P, Vector::multiply(_V, lambda, tv), point1);
			Vector::add(ray._P, Vector::multiply(ray._V, mu, tv), point2);
		}
		return true;
	}
	return false;
}


// Distance between two rays
double Ray::dist(const Ray &ray) const {
	Vector point1, point2;
	if (adjacentPoints(ray, point1, point2))
		return point1.dist(point2);
	else
		return 0.0;
}


// Distance between a ray and a point
double Ray::dist(const Vector &point) const {
	if (isValid() && point.isValid()) {
		Vector tv, point2;
		double lambda = Vector::dot(_V, point-_P);
		Vector::add(_P, Vector::multiply(_V, lambda, tv), point2);
		return point.dist(point2);
	}
	return 0.0;
}
