// directly, apart from some name changes and removals, ripped off from NeHe tutorial #30
// (read explanation near function do2005Physics() in beginning.cc)
#ifndef tray_h
#define tray_h

#include "vector.hh"

///////////////////////////////////////////////////////////////////////
//  Class Line
///////////////////////////////////////////////////////////////////////

class Ray {
	private:
		Vector _P; // Any point on the line
		Vector _V; // Direction of the line

	// Close

	public:
		// Constructors
		Ray() {}

		// Line betwen two points OR point and a direction
		Ray(const Vector &point1, const Vector &point2);

		// Adjacent points on both lines
		bool adjacentPoints(const Ray &ray, Vector &point1, Vector &point2) const;

		// Unary operator
		static Ray &invert(const Ray &r, Ray result) { result._P = r._P; Vector::invert(r._V, result._V); return result; }
		Ray operator-() const { return invert(*this, Ray()); }

		// Selectors
		Vector P() const { return _P; }
		Vector V() const { return _V; }
		int isValid() const { return V().isUnit() && P().isValid(); }

		// Distances
		double dist(const Ray &ray) const;
		double dist(const Vector &point) const;
};
#endif
