// directly, apart from some name changes and removals, ripped off from NeHe tutorial #30
// (read explanation near function do2005Physics() in beginning.cc)
/*******************************************************************************/
/*********************************21/09/200*************************************/
/**********************Programmer: Dimitrios Christopoulos**********************/
/**********************for the oglchallenge contest*****************************/
/**********************COLLISION CRAZY******************************************/
/*******************************************************************************/
#include "vector.hh"
#include "ray.hh"
// Mid point between two rays
Vector::Vector(const Ray &ray1, const Ray &ray2) {
	Vector point1, point2;
	if (ray1.adjacentPoints(ray2, point1, point2))
		*this = (point1 + point2)*0.5;
	else
		*this = Vector();
}

// Make a unit vector
Vector &Vector::unit() {
	if (isDefault()) {
		double rep = mag();
		if (rep < 1.0e-8) {
			_x = 0.0;
			_y = 0.0;
			_z = 0.0;
		} else {
			double temp = 1.0 / rep;
			_x *= temp;
			_y *= temp;
			_z *= temp;
		}
		_Status = UNIT;
	}
	return *this;
}

// Make a default vector
Vector &Vector::Default() {
	if (isUnit())
		_Status = DEFAULT;
	return *this;
}

Vector &Vector::invert(const Vector &v1, Vector result) {
	if (v1.isValid()) {
	    
		result._x = -v1._x;
		result._y = -v1._y;
		result._z = -v1._z;
		result._Status = v1._Status;
	} else
		result = Vector();
	return result;
}

Vector &Vector::add(const Vector &v1, const Vector &v2, Vector &result) {
	if (v1.isValid() && v2.isValid()) {
		result._x = v1._x + v2._x;
		result._y = v1._y + v2._y;
		result._z = v1._z + v2._z;
		result._Status = DEFAULT;
	} else
		result = Vector();
	return result;
}

Vector &Vector::subtract(const Vector &v1, const Vector &v2, Vector &result) {
	if (v1.isValid() && v2.isValid()) {
		result._x = v1._x - v2._x;
		result._y = v1._y - v2._y;
		result._z = v1._z - v2._z;
		result._Status = DEFAULT;
	} else
		result = Vector();
	return result;
}

Vector &Vector::cross(const Vector &v1, const Vector &v2, Vector &result) {
	if (v1.isValid() && v2.isValid()) {
		result._x = v1._y * v2._z - v1._z * v2._y;
		result._y = v1._z * v2._x - v1._x * v2._z;
		result._z = v1._x * v2._y - v1._y * v2._x;
		result._Status = DEFAULT;
	} else
		result = Vector();
	return result;
}

Vector &Vector::multiply(const Vector &v1, const double &scale, Vector &result) {
	if (v1.isValid()) {
		result._x = v1._x * scale;
		result._y = v1._y * scale;
		result._z = v1._z * scale;
		result._Status = DEFAULT;
	} else
		result = Vector();
	return result;
}
